/*******************************************************************************
 * Copyright (c) 2012, 2013 Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.objmap.forward;

import org.simantics.db.ReadGraph;
import org.simantics.objmap.exceptions.MappingException;

/**
 * Contains rules for creating and updating range elements for given
 * domain elements.
 * @author Hannu Niemist&ouml;
 */
public interface IForwardLinkType<Domain, Range> extends IForwardMappingRule<Domain, Range> {
    /**
     * Creates a range element based on a known domain element.
     */
    Range createRangeElement(ReadGraph graph, Domain domainElement) throws MappingException;
}
