/*******************************************************************************
 * Copyright (c) 2007, 2013 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.objmap.graph.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.simantics.objmap.graph.annotations.meta.IsFieldRule;
import org.simantics.objmap.graph.rules.adapters.IdentityAdapter;
import org.simantics.objmap.graph.rules.adapters.ValueAdapter;



/**
 * Specifies a correspondence between a field and 
 * functional property.
 * @author Hannu Niemist
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
@IsFieldRule
public @interface RelatedValue {
    String value();
    Class<? extends ValueAdapter> adapter() default IdentityAdapter.class;
}
