/*******************************************************************************
 * Copyright (c) 2007, 2013 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.objmap.graph.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.simantics.objmap.graph.annotations.meta.IsFieldRule;



/**
 * Specifies that the annotated method should be called
 * to update range object.
 * @author Hannu Niemist
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@IsFieldRule
public @interface UpdateMethod {
}
