package org.simantics.objmap.structural.schema;

import java.util.ArrayList;

import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.utils.OrderedSetUtils;
import org.simantics.db.exception.DatabaseException;
import org.simantics.objmap.bidirectional.IBidirectionalMappingRule;
import org.simantics.objmap.structural.IStructuralObject;
import org.simantics.objmap.structural.StructuralResource;

public class OrderedSetSimpleLinkType extends SimpleLinkType {

	public OrderedSetSimpleLinkType(Resource domainType, Class<?> rangeType, ArrayList<IBidirectionalMappingRule<StructuralResource, IStructuralObject>> rules) {
		super(domainType, rangeType, rules);
	}

	public OrderedSetSimpleLinkType(Resource domainType, Class<?> rangeType) {
		super(domainType, rangeType);
	}
	
	@Override
	protected Resource newResource(WriteGraph g, Resource type) throws DatabaseException {
		return OrderedSetUtils.create(g, type);
	}

}
